
/*
 * bullet patterns
 */

void fire_bullet(WORD sx, WORD sy) {

	SETUP( (&Bullet[0]), sx, sy, 3,  1);
	SETUP( (&Bullet[1]), sx, sy, 2,  2);
	SETUP( (&Bullet[2]), sx, sy, 0,  3);
	SETUP( (&Bullet[3]), sx, sy, -2, 2);
	SETUP( (&Bullet[4]), sx, sy, -3, 1);
	
}

void fire_bullet_straight(WORD sx, WORD sy, BYTE id) {
	SETUP( (&Bullet[id]), sx, sy, 0, 3 );
}

void fire_bullet_right(WORD sx, WORD sy, BYTE id) {
	SETUP( (&Bullet[id]), sx, sy, 8, 0 );
}


/*
 * plot
 */
 
BYTE total_kills = 0;
BYTE plot_timer = 0;

/*
 * STAGE1
 */

void stage1_init() {
	SETUP( (&Enemies[0]), PX_TO_FX(50), PX_TO_FX(50), 0, 0 );
	Enemies[0].hp = 1;
	set_sprite_tile(SPR_ENEMY_1, TILE_ENEMY_A);
}

stage1_tick() {
	if (plot_timer == 40) {
		Enemies[0].velocity_x = 4;
	}
	if (plot_timer == 80) {
		Enemies[0].velocity_x = 0;
	}
	if (plot_timer == 120) {
		Enemies[0].velocity_y = 4;
	}
	if (plot_timer == 160) {
		Enemies[0].velocity_y = 0;
		fire_bullet( PX_TO_FX(70), PX_TO_FX(70) );
	}
	if (plot_timer == 200) {
		Enemies[0].velocity_y = -4;
		Enemies[0].velocity_x = -4;
	}
	if (plot_timer == 240) {
		Enemies[0].velocity_y = 0;
		Enemies[0].velocity_x = 0;
	}
	
}

/*
 * STAGE2
 */

void stage2_init() {
	SETUP( (&Enemies[0]), PX_TO_FX(30), PX_TO_FX(30), 0, 0 );
	SETUP( (&Enemies[1]), PX_TO_FX(130), PX_TO_FX(30), 0, 0);
	
	Enemies[0].hp = 2;
	Enemies[1].hp = 2;
	set_sprite_tile(SPR_ENEMY_1, TILE_ENEMY_B);
	set_sprite_tile(SPR_ENEMY_2, TILE_ENEMY_B);
}

void stage2_tick() {
	if (is_visible(&Enemies[0])) {
		if (plot_timer == 40) {
			Enemies[0].velocity_y = 3;
			Enemies[0].velocity_x = 3;
		}
		if (plot_timer == 120) {
			Enemies[0].velocity_y = -3;
			Enemies[0].velocity_x = -3;
			fire_bullet_straight( 0, 0, 2 );
			copy_position( &Bullet[2], &Enemies[0] );
		}
		if (plot_timer == 200) {
			Enemies[0].velocity_x = 0;
			Enemies[0].velocity_y = 0;
			fire_bullet_straight( 0, 0, 0 );
			copy_position( &Bullet[0], &Enemies[0] );
		}			
	}

	if (is_visible(&Enemies[1])) {
		if (plot_timer == 80) {
			Enemies[1].velocity_y = 3;
			Enemies[1].velocity_x = -3;
		}
		
		if (plot_timer == 160) {
			Enemies[1].velocity_y = -3;
			Enemies[1].velocity_x = 3;
			fire_bullet_straight( 0, 0, 3 );
			copy_position( &Bullet[3], &Enemies[1] );
		}
		
		if (plot_timer == 240) {
			Enemies[1].velocity_x = 0;
			Enemies[1].velocity_y = 0;
			fire_bullet_straight( 0, 0, 1 );
			copy_position( &Bullet[1], &Enemies[1] );
		}
	}
}

/*
 * STAGE3
 */

void stage3_init() {
	SETUP( (&Enemies[0]), PX_TO_FX(80), PX_TO_FX(20), 1, 0);
	SETUP( (&Enemies[1]), PX_TO_FX(80), PX_TO_FX(35), -3, 0);
	SETUP( (&Enemies[2]), PX_TO_FX(80), PX_TO_FX(50), 5, 0);
	SETUP( (&Enemies[3]), PX_TO_FX(80), PX_TO_FX(65), -7, 0);
	
	Enemies[0].hp = 3;
	Enemies[1].hp = 3;
	Enemies[2].hp = 3;
	Enemies[3].hp = 3;
	
	set_sprite_tile(SPR_ENEMY_1, TILE_ENEMY_C);
	set_sprite_tile(SPR_ENEMY_2, TILE_ENEMY_C);
	set_sprite_tile(SPR_ENEMY_3, TILE_ENEMY_C);
	set_sprite_tile(SPR_ENEMY_4, TILE_ENEMY_C);
}

void reverse_x_velocity(moveable* o) {
	if (o->xpos < PX_TO_FX(20) || o->xpos > PX_TO_FX(140)) {
		o->velocity_x = - o->velocity_x;
	}
}

void stage3_tick() {
	BYTE i;
	if (! (plot_timer % 20)) {
		for (i = 0; i != 4; ++i) {
			if (is_visible(&Enemies[i])) {
			
				reverse_x_velocity( &Enemies[i] );
			
			}
		}
	}
	
	if (plot_timer == 0) {
		fire_bullet_straight( 0, 0, 0 );
		copy_position(&Bullet[0], &Enemies[0]);
	}
	if (plot_timer == 64) {
		fire_bullet_straight( 0, 0, 1 );
		copy_position(&Bullet[1], &Enemies[1]);
	}
	if (plot_timer == 128) {
		fire_bullet_straight( 0, 0, 2 );
		copy_position(&Bullet[2], &Enemies[2]);
	}
	if (plot_timer == 192) {
		fire_bullet_straight( 0, 0, 3 );
		copy_position(&Bullet[3], &Enemies[3]);
	}
}

/*
 * STAGE4
 */

void stage4_init() {
	SETUP( (&Enemies[0]), PX_TO_FX(85), PX_TO_FX(40), 0, 0 );
	Enemies[0].hp = 10;
	set_sprite_tile(SPR_ENEMY_1, TILE_ENEMY_D);
}

void stage4_process(BYTE pt, WORD x, WORD y, BYTE b) {
	if (plot_timer == pt) {
		SETUP( (&Enemies[0]), PX_TO_FX( x ), PX_TO_FX( y ), 0, 0 );
		fire_bullet_right( PX_TO_FX( x ), PX_TO_FX( y ), b );
	}
}
	
void stage4_tick() {
	if (is_visible(&Enemies[0])) {
		
		if (plot_timer == 0) {
			SETUP( (&Enemies[0]), PX_TO_FX(85), PX_TO_FX(40), 0, 0 );
		}
		
		stage4_process(20,  10, 140, 0);
		stage4_process(40,  10, 125, 1);
		stage4_process(60,  10, 110, 2);
		stage4_process(80,  10,  95, 3);
		stage4_process(100, 10,  80, 4);
		
		if (plot_timer == 160) {
			SETUP( (&Enemies[0]), PX_TO_FX(85), PX_TO_FX(40), 0, 0 );
		}
		
	}
}

/*
 * Handlers
 */

void on_kill() {
	HIDE_SPRITES;
	plot_timer = 0;

	switch(total_kills) {
		case 0: {
			stage1_init();
		} break;
		
		case 1: {
			stage2_init();
		} break;
		
		case 3: {
			stage3_init();
		} break;
		
		case 7: {
			stage4_init();
		} break;
	}
	
	SHOW_SPRITES;
}

void plot_progress() {
	
	if (total_kills == 0) {
		stage1_tick();
	
	} else if (total_kills == 1 || total_kills == 2) {
		stage2_tick();
		
	} else if (total_kills >= 3 && total_kills < 7) {
		stage3_tick();
		
	} else if (total_kills == 7) {
		stage4_tick();
		
	} else if (total_kills == 8) {
		// gameover
		
	}
	
	++plot_timer;
}
